1#! /bin/sh 
2# Embed an SPU ELF executable into a PowerPC object file.
3#
4# Copyright 2006, 2007 Free Software Foundation, Inc.
5#
6# This file is part of GNU Binutils.
7#
8# This program is free software; you can redistribute it and/or modify
9# it under the terms of the GNU General Public License as published by
10# the Free Software Foundation; either version 2 of the License, or
11# (at your option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
20# Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
21# 02110-1301, USA.
22
23usage ()
24{
25  echo "Usage: embedspu [flags] symbol_name input_filename output_filename"
26  echo
27  echo "        input_filename:  SPU ELF executable to be embedded"
28  echo "        output_filename: Resulting PowerPC object file"
29  echo "        symbol_name:     Name of program handle struct to be defined"
30  echo "        flags:           GCC flags defining PowerPC object file format"
31  echo "                         (e.g. -m32 or -m64)"
32  exit 1
33}
34
35program_transform_name=
36mydir=`dirname "$0"`
37
38find_prog ()
39{
40  prog=`echo $1 | sed "$program_transform_name"`
41  prog="$mydir/$prog"
42  test -x "$prog" && return 0
43  prog="$mydir/$1"
44  test -x "$prog" && return 0
45  prog=`echo $1 | sed "$program_transform_name"`
46  which $prog > /dev/null 2> /dev/null && return 0
47  return 1
48}
49
50SYMBOL=
51INFILE=
52OUTFILE=
53FLAGS=
54
55parse_args ()
56{
57  while test -n "$1"; do
58    case "$1" in
59      -*) FLAGS="${FLAGS} $1" ;;
60      *)  if test -z "$SYMBOL"; then
61	    SYMBOL="$1"
62	  elif test -z "$INFILE"; then
63	    INFILE="$1"
64	  elif test -z "$OUTFILE"; then
65	    OUTFILE="$1"
66	  else
67	    echo "Too many arguments!"
68	    usage
69	  fi ;;
70    esac
71    shift
72  done
73  if test -z "$OUTFILE"; then
74    usage
75  fi
76  if test ! -r "$INFILE"; then
77    echo "${INFILE}: File not found"
78    usage
79  fi
80}
81
82main ()
83{
84  parse_args "$@"
85
86  # Find a powerpc gcc.  Support running from a combined tree build.
87  if test -x "$mydir/../gcc/xgcc"; then
88    CC="$mydir/../gcc/xgcc -B$mydir/../gcc/"
89  else
90    find_prog gcc
91    if test $? -ne 0; then
92      echo "Cannot find $prog"
93      exit 1
94    fi
95    CC="$prog"
96  fi
97
98  # Find readelf.  Any old readelf should do.
99  find_prog readelf
100  if test $? -ne 0; then
101    if which readelf > /dev/null 2> /dev/null; then
102      prog=readelf
103    else
104      echo "Cannot find $prog"
105      exit 1
106    fi
107  fi
108  READELF="$prog"
109
110  # Sanity check the input file
111  if ! ${READELF} -h ${INFILE} | grep 'Class:.*ELF32' >/dev/null 2>/dev/null \
112     || ! ${READELF} -h ${INFILE} | grep 'Type:.*EXEC' >/dev/null 2>/dev/null \
113     || ! ${READELF} -h ${INFILE} | egrep 'Machine:.*(SPU|17)' >/dev/null 2>/dev/null
114  then
115    echo "${INFILE}: Does not appear to be an SPU executable"
116    exit 1
117  fi
118
119  toe=`${READELF} -S ${INFILE} | sed -n -e 's, *\[ *\([0-9]*\)\] *\.toe *[PROGN]*BITS *\([0-9a-f]*\).*,\1 \2,p'`
120  toe_addr=`echo $toe | sed -n -e 's,.* ,,p'`
121  toe=`echo $toe | sed -n -e 's, .*,,p'`
122  # For loaded sections, pick off section number, address, and file offset
123  sections=`${READELF} -S ${INFILE} | sed -n -e 's, *\[ *\([0-9]*\)\] *[^ ]* *PROGBITS *\([0-9a-f]*\) *\([0-9a-f]*\).*,\1 \2 \3,p'`
124  sections=`echo ${sections}`
125  # For relocation sections, pick off file offset and info (points to
126  # section where relocs apply)
127  relas=`${READELF} -S ${INFILE} | sed -n -e 's, *\[ *[0-9]*\] *[^ ]* *RELA *[0-9a-f]* *0*\([0-9a-f][0-9a-f]*\).* \([0-9a-f][0-9a-f]*\) *[0-9a-f][0-9a-f]*$,\1 \2,p'`
128  relas=`echo ${relas}`
129
130  # Build embedded SPU image.
131  # 1. The whole SPU ELF file is written to .rodata.speelf
132  # 2. Symbols starting with the string "_EAR_" in the SPU ELF image are
133  #    special.  They allow an SPU program to access corresponding symbols
134  #    (ie. minus the _EAR_ prefix), in the PowerPC program.  _EAR_ without
135  #    a suffix is used to refer to the addrress of the SPU image in
136  #    PowerPC address space.  _EAR_* symbols must all be defined in .toe
137  #    at 16 byte intervals, or they must be defined in other non-bss
138  #    sections.
139  #    Find all _EAR_ symbols in .toe using readelf, sort by address, and
140  #    write the address of the corresponding PowerPC symbol in a table
141  #    built in .data.spetoe.  For _EAE_ symbols not in .toe, create
142  #    .reloc commands to relocate their location directly.
143  # 3. Look for R_SPU_PPU32 and R_SPU_PPU64 relocations in the SPU ELF image
144  #    and create .reloc commands for them.
145  # 4. Write a struct spe_program_handle to .data.
146  # 5. Write a table of _SPUEAR_ symbols.
147  ${CC} ${FLAGS} -x assembler-with-cpp -nostartfiles -nostdlib \
148	-Wa,-mbig -Wl,-r -Wl,-x -o ${OUTFILE} - <<EOF
149 .section .data.spetoe,"aw",@progbits
150 .p2align 7
151__spetoe__:
152`${READELF} -s -W ${INFILE} | grep ' _EAR_' | sort -k 2 | awk \
153'BEGIN { \
154	addr = strtonum ("0x" "'${toe_addr-0}'"); \
155	split ("'"${sections}"'", s, " "); \
156	for (i = 1; i in s; i += 3) { \
157	    sec_off[s[i]] = strtonum ("0x" s[i+2]) - strtonum ("0x" s[i+1]); \
158	} \
159} \
160$7 == "'${toe}'" && strtonum ("0x" $2) != addr { \
161	print "#error Symbol " $8 " not in 16 byte element toe array!"; \
162} \
163$7 == "'${toe}'" { \
164	addr = addr + 16; \
165} \
166$7 == "'${toe}'" { \
167	print "#ifdef _LP64"; \
168	print " .quad " ($8 == "_EAR_" ? "__speelf__" : substr($8, 6)) ", 0"; \
169	print "#else"; \
170	print " .int 0, " ($8 == "_EAR_" ? "__speelf__" : substr($8, 6)) ", 0, 0"; \
171	print "#endif"; \
172} \
173$7 != "'${toe}'" && $7 in sec_off { \
174	print "#ifdef _LP64"; \
175	print " .reloc __speelf__+" strtonum ("0x" $2) + sec_off[$7] ", R_PPC64_ADDR64, " ($8 == "_EAR_" ? "__speelf__" : substr($8, 6)); \
176	print "#else"; \
177	print " .reloc __speelf__+" strtonum ("0x" $2) + sec_off[$7] + 4 ", R_PPC_ADDR32, " ($8 == "_EAR_" ? "__speelf__" : substr($8, 6)); \
178	print "#endif"; \
179	if (!donedef) { print "#define HAS_RELOCS 1"; donedef = 1; }; \
180} \
181$7 != "'${toe}'" && ! $7 in sec_off { \
182	print "#error Section not found for " $8; \
183} \
184'`
185`test -z "${relas}" || ${READELF} -r -W ${INFILE} | awk \
186'BEGIN { \
187	split ("'"${sections}"'", s, " "); \
188	for (i = 1; i in s; i += 3) { \
189	    sec_off[s[i]] = strtonum ("0x" s[i+2]) - strtonum ("0x" s[i+1]); \
190	} \
191	split ("'"${relas}"'", s, " "); \
192	for (i = 1; i in s; i += 2) { \
193	    rela[s[i]] = strtonum (s[i+1]); \
194	} \
195} \
196/^Relocation section/ { \
197	sec = substr($6, 3); \
198} \
199$3 ~ /R_SPU_PPU/ { \
200	print "#ifdef _LP64"; \
201	print " .reloc __speelf__+" strtonum ("0x" $1) + sec_off[rela[sec]] ", R_PPC64_ADDR" substr($3, 10) ", " ($5 != "" ? $5 "+0x" $7 : "__speelf__ + 0x" $4); \
202	print "#else"; \
203	print " .reloc __speelf__+" strtonum ("0x" $1) + sec_off[rela[sec]] + (substr($3, 10) == "64" ? 4 : 0)", R_PPC_ADDR32, " ($5 != "" ? $5 "+0x" $7 : "__speelf__ + 0x" $4); \
204	print "#endif"; \
205	if (!donedef) { print "#define HAS_RELOCS 1"; donedef = 1; }; \
206} \
207$3 ~ /unrecognized:/ { \
208	print "#ifdef _LP64"; \
209	print " .reloc __speelf__+" strtonum ("0x" $1) + sec_off[rela[sec]] ", R_PPC64_ADDR" ($4 == "f" ? "64" : "32") ", " ($6 != "" ? $6 "+0x" $8 : "__speelf__ + 0x" $5); \
210	print "#else"; \
211	print " .reloc __speelf__+" strtonum ("0x" $1) + sec_off[rela[sec]] + ($4 == "f" ? 4 : 0)", R_PPC_ADDR32, " ($6 != "" ? $6 "+0x" $8 : "__speelf__ + 0x" $5); \
212	print "#endif"; \
213	if (!donedef) { print "#define HAS_RELOCS 1"; donedef = 1; }; \
214} \
215'`
216#if defined (HAS_RELOCS) && (defined (__PIC__) || defined (__PIE__))
217 .section .data.rel.ro.speelf,"a",@progbits
218#else
219 .section .rodata.speelf,"a",@progbits
220#endif
221 .p2align 7
222__speelf__:
223 .incbin "${INFILE}"
224
225 .section .data,"aw",@progbits
226 .globl ${SYMBOL}
227 .type ${SYMBOL}, @object
228# fill in a struct spe_program_handle
229#ifdef _LP64
230 .p2align 3
231${SYMBOL}:
232 .int 24
233 .int 0
234 .quad __speelf__
235 .quad __spetoe__
236#else
237 .p2align 2
238${SYMBOL}:
239 .int 12
240 .int __speelf__
241 .int __spetoe__
242#endif
243 .size ${SYMBOL}, . - ${SYMBOL}
244
245`${READELF} -s -W ${INFILE} | grep ' _SPUEAR_' | sort -k 2 | awk \
246'{ \
247	print " .globl '${SYMBOL}'_" substr($8, 9); \
248	print " .type '${SYMBOL}'_" substr($8, 9) ", @object"; \
249	print " .size '${SYMBOL}'_" substr($8, 9) ", 4"; \
250	print "'${SYMBOL}'_" substr($8, 9) ":"; \
251	print " .int 0x" $2; \
252} \
253'`
254EOF
255}
256
257main "$@"
258